Loading...
Searching...
No Matches
XrdSsi Namespace Reference

## Classes

class | ShMap
struct | ShMap_Parms

## Typedefs

typedef int(* | ShMap_Hash_t) (const char *key)

## Enumerations

enum | ShMap_Access { ReadOnly = 1 , ReadWrite = 2 }
| The action parameter that must be passed to the Attach() method. More...
enum | SyncOpt { SyncOff = 0 , SyncOn , SyncAll , SyncNow , SyncQSz }
| Options valid for the Sync() method. More...

## Functions

| Atomic (bool) initDone(false)
| Atomic (int) contactN(1)
XrdSysError | Log (0, "ssi_")
XrdSysTrace | Trace ("Ssi", Logger)

## Variables

XrdOucBuffPool * | BuffPool = 0
XrdCl::Env * | clEnvP = 0
XrdSysMutex | clMutex
bool | detReqOK = false
bool | dsTTLSet = false
XrdOucBuffPool | EmsgPool
bool | fsChk = false
XrdOucPListAnchor | FSPath
bool | hiResTime = false
XrdSysError | Log
XrdSysLogger * | Logger = 0
short | maxCLW = 30
short | maxPEL = 10
int | maxRSZ = 2097152
short | maxTCB = 300
int | minRSZ = 1024
XrdSsiLogger::MCB_t * | msgCB = 0
XrdSsiLogger::MCB_t * | msgCBCl = 0
XrdNetIF * | myIF = 0
XrdSsiProvider * | Provider = 0
char | rDisp = rDispRR
static const int | rDispNone = 0
static const int | rDispRand = -1
static const int | rDispRR = 1
bool | reqTOSet = false
int | respWT = 0x7fffffff
XrdScheduler * | Sched = 0
XrdScheduler * | schedP = 0
XrdSsiService * | Service = 0
static const int | ShMap_4Resize = -1
XrdSsiScale | sidScale
XrdSsiCms * | SsiCms = 0
XrdSsiLogger | SsiLogger
XrdSsiStats | Stats
bool | strTOSet = false
XrdSfsFileSystem * | theFS = 0
XrdSysTrace | Trace
XrdSsiMutex | ubMutex (XrdSsiMutex::Recursive)

## Detailed Description

This include file defines a simple key-value store interface using shared memory. This allows you to share the map with other processes in read as well as read/write mode. See the XrdSsi::ShMap teplated class within.

This file defines a default plug-in that can be used to handle stat() calls for the Scalable Service Interface.

## Typedef Documentation

## ShMap_Hash_t

typedef int(* XrdSsi::ShMap_Hash_t) (const char *key)

Typedef for the optional hash computation function (see constructor)

Parameters

  key | Pointer to the key whose hash is to be returned. If nil the function should return its 4-character name (e.g. {int hash; memcpy(&hash, "c32 ", sizeof(int)); return hash;}

Returns
  Either the hash value of the key or the hash name as an int.

Definition at line 122 of file XrdSsiShMap.hh.

## Enumeration Type Documentation

## ShMap_Access

enum XrdSsi::ShMap_Access

The action parameter that must be passed to the Attach() method.

< Attach existing map for

Enumerator
ReadOnly | reading
ReadWrite | reading & writing

Definition at line 49 of file XrdSsiShMap.hh.

{ReadOnly = 1,
ReadWrite = 2
};
XrdSsi::ReadOnly
@ ReadOnly
reading
Definition XrdSsiShMap.hh:50
XrdSsi::ReadWrite
@ ReadWrite
reading & writing
Definition XrdSsiShMap.hh:51

## SyncOpt

enum XrdSsi::SyncOpt

Options valid for the Sync() method.

Enumerator
SyncOff |
SyncOn |
SyncAll |
SyncNow |
SyncQSz |

Definition at line 110 of file XrdSsiShMap.hh.

{SyncOff = 0, SyncOn, SyncAll, SyncNow, SyncQSz};
XrdSsi::SyncNow
@ SyncNow
Definition XrdSsiShMap.hh:110
XrdSsi::SyncQSz
@ SyncQSz
Definition XrdSsiShMap.hh:110
XrdSsi::SyncOn
@ SyncOn
Definition XrdSsiShMap.hh:110
XrdSsi::SyncAll
@ SyncAll
Definition XrdSsiShMap.hh:110
XrdSsi::SyncOff
@ SyncOff
Definition XrdSsiShMap.hh:110

## Function Documentation

## Atomic() [1/2]

XrdSsi::Atomic | ( | bool |  | ) |

## Atomic() [2/2]

XrdSsi::Atomic | ( | int |  | ) |

## Log()

XrdSysError XrdSsi::Log | ( | 0 | ,
|  | "ssi_" | )

## Trace()

XrdSysTrace XrdSsi::Trace | ( | "Ssi" | ,
|  | Logger | )

References Logger.

## Variable Documentation

## BuffPool

XrdOucBuffPool * XrdSsi::BuffPool = 0

Definition at line 89 of file XrdSsiSfsConfig.cc.

Referenced by XrdSsiFileSess::write().

## clEnvP

XrdCl::Env* XrdSsi::clEnvP = 0

Definition at line 75 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetTimeout().

## clMutex

XrdSysMutex XrdSsi::clMutex

Definition at line 73 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), XrdSsiClientProvider::SetCBThreads(), XrdSsiClientProvider::SetConfig(), and XrdSsiClientProvider::SetTimeout().

## detReqOK

bool XrdSsi::detReqOK = false

Definition at line 108 of file XrdSsiSfsConfig.cc.

## dsTTLSet

bool XrdSsi::dsTTLSet = false

Definition at line 81 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetTimeout().

## EmsgPool

XrdOucBuffPool XrdSsi::EmsgPool

Definition at line 53 of file XrdSsiFile.cc.

## fsChk

bool XrdSsi::fsChk = false

Definition at line 56 of file XrdSsiFile.cc.

Referenced by XrdSsiSfs::chksum(), XrdSsiSfs::chmod(), XrdSsiSfsConfig::Configure(), XrdSsiSfs::exists(), XrdSsiSfs::fsctl(), XrdSsiSfs::mkdir(), XrdSsiDir::open(), XrdSsiFile::open(), XrdSsiSfs::rem(), XrdSsiSfs::remdir(), XrdSsiSfs::rename(), XrdSsiSfs::stat(), XrdSsiSfs::stat(), XrdSsiSfs::truncate(), XrdSsiStatInfo(), and XrdVERSIONINFO().

## FSPath

XrdOucPListAnchor XrdSsi::FSPath

Definition at line 55 of file XrdSsiFile.cc.

Referenced by XrdSsiSfs::chmod(), XrdSsiSfsConfig::Configure(), XrdSsiSfs::exists(), XrdSsiSfs::fsctl(), XrdSsiSfs::mkdir(), XrdSsiDir::open(), XrdSsiFile::open(), XrdSsiSfs::rem(), XrdSsiSfs::remdir(), XrdSsiSfs::rename(), XrdSsiSfs::stat(), XrdSsiSfs::stat(), XrdSsiSfs::truncate(), XrdSsiStatInfo(), and XrdVERSIONINFO().

## hiResTime

bool XrdSsi::hiResTime = false

Definition at line 84 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::SetConfig().

## Log

XrdSysError XrdSsi::Log

Definition at line 66 of file XrdSsiFileReq.cc.

Referenced by XrdSsiSfsConfig::Configure(), XrdSsiSfsConfig::Configure(), XrdSsiFileReq::DoIt(), XrdSsiUtils::Emsg(), XrdSsiFileReq::Finalize(), XrdSsiScale::getEnt(), XrdSsiTaskReal::Kill(), XrdSsiLogger::Msg(), XrdSsiLogger::Msgf(), XrdSsiLogger::Msgv(), XrdSsiFileSess::open(), XrdSsiTaskReal::SendRequest(), XrdSsiFileSess::write(), XrdSsiTaskReal::XeqEvent(), XrdOssStatInfoInit2(), XrdSfsGetFileSystem2(), and XrdVERSIONINFO().

## Logger

XrdSysLogger * XrdSsi::Logger = 0

Definition at line 57 of file XrdSsiLogger.cc.

Referenced by XrdSsiClientProvider::GetService(), and Trace().

## maxCLW

short XrdSsi::maxCLW = 30

Definition at line 78 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::SetCBThreads(), and XrdSsiClientProvider::SetConfig().

## maxPEL

short XrdSsi::maxPEL = 10

Definition at line 79 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetConfig().

## maxRSZ

int XrdSsi::maxRSZ = 2097152

Definition at line 104 of file XrdSsiSfsConfig.cc.

Referenced by XrdSsiFileSess::write().

## maxTCB

short XrdSsi::maxTCB = 300

Definition at line 77 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::SetCBThreads(), and XrdSsiClientProvider::SetConfig().

## minRSZ

int XrdSsi::minRSZ = 1024

Definition at line 103 of file XrdSsiSfsConfig.cc.

Referenced by XrdSsiFileSess::write().

## msgCB

XrdSsiLogger::MCB_t * XrdSsi::msgCB = 0

Definition at line 59 of file XrdSsiLogger.cc.

Referenced by XrdSsiLogger::SetMCB(), and XrdSysLogPInit().

## msgCBCl

XrdSsiLogger::MCB_t * XrdSsi::msgCBCl = 0

Definition at line 60 of file XrdSsiLogger.cc.

Referenced by XrdSsiLogger::SetMCB().

## myIF

XrdNetIF * XrdSsi::myIF = 0

Definition at line 93 of file XrdSsiSfsConfig.cc.

Referenced by XrdSsiSfsConfig::Configure(), XrdSsiSfs::fsctl(), and XrdVERSIONINFO().

## Provider

XrdSsiProvider * XrdSsi::Provider = 0

Definition at line 39 of file XrdSsiService.cc.

Referenced by XrdSsiSfs::fsctl(), XrdSsiService::Prepare(), XrdSsiStatInfo(), and XrdVERSIONINFO().

## rDisp

char XrdSsi::rDisp = rDispRR

Definition at line 90 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetConfig().

## rDispNone

const int XrdSsi::rDispNone = 0

static

Definition at line 86 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetConfig().

## rDispRand

const int XrdSsi::rDispRand = -1

static

Definition at line 87 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::SetConfig().

## rDispRR

const int XrdSsi::rDispRR = 1

static

Definition at line 88 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetConfig().

## reqTOSet

bool XrdSsi::reqTOSet = false

Definition at line 82 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetTimeout().

## respWT

int XrdSsi::respWT = 0x7fffffff

Definition at line 101 of file XrdSsiSfsConfig.cc.

Referenced by XrdSsiSfsConfig::XrdSsiSfsConfig(), and XrdSsiFileSess::fctl().

## Sched

XrdScheduler * XrdSsi::Sched = 0

Definition at line 87 of file XrdSsiSfsConfig.cc.

Referenced by XrdSsiFileReq::Activate(), XrdSsiSfsConfig::Configure(), and XrdSsiFileReq::DeferredFinalize().

## schedP

XrdScheduler * XrdSsi::schedP = 0

Definition at line 74 of file XrdSsiClient.cc.

Referenced by XrdSsiEvent::AddEvent(), XrdSsiClientProvider::GetService(), XrdSsiUtils::RetErr(), XrdSsiTaskReal::SchedError(), and XrdSsiSessReal::UnHold().

## Service

XrdSsiService * XrdSsi::Service = 0

Definition at line 72 of file XrdSsiFileSess.cc.

Referenced by XrdSsiFileReq::DoIt(), and XrdSsiFileSess::open().

## ShMap_4Resize

const int XrdSsi::ShMap_4Resize = -1

static

Parameters to pass to Create(). For Resize(&parms) initialize the struct as: "ShMap_Parms parms(XrdSsi::ShMap_Parms::ForResize)" so that the default values are appropriate for resizing instead of creation.

Definition at line 60 of file XrdSsiShMap.hh.

## sidScale

XrdSsiScale XrdSsi::sidScale

Definition at line 52 of file XrdSsiServReal.cc.

Referenced by XrdSsiServReal::ProcessRequest(), XrdSsiSessReal::Provision(), XrdSsiSessReal::Run(), XrdSsiClientProvider::SetSpread(), and XrdSsiSessReal::TaskFinished().

## SsiCms

XrdSsiCms* XrdSsi::SsiCms = 0

Definition at line 85 of file XrdSsiSfsConfig.cc.

## SsiLogger

XrdSsiLogger XrdSsi::SsiLogger

Definition at line 99 of file XrdSsiSfsConfig.cc.

## Stats

XrdSsiStats XrdSsi::Stats

Definition at line 69 of file XrdSsiFileReq.cc.

Referenced by XrdSsiFileReq::Activate(), XrdSsiCms::Added(), XrdSsiFileReq::Alert(), XrdSsiFileSess::AttnInfo(), XrdSsiFileSess::close(), XrdSsiFileReq::DoIt(), XrdSsiFileSess::fctl(), XrdSsiFileReq::Finalize(), XrdSsiFileReq::GetRequest(), XrdSsiSfs::getStats(), XrdSsiFileSess::open(), XrdSsiFileReq::ProcessResponse(), XrdSsiFileReq::RelRequestBuffer(), XrdSsiCms::Removed(), and XrdSfsGetFileSystem2().

## strTOSet

bool XrdSsi::strTOSet = false

Definition at line 83 of file XrdSsiClient.cc.

Referenced by XrdSsiClientProvider::GetService(), and XrdSsiClientProvider::SetTimeout().

## theFS

XrdSfsFileSystem * XrdSsi::theFS = 0

Definition at line 54 of file XrdSsiFile.cc.

Referenced by XrdSsiSfs::chksum(), XrdSsiSfs::chmod(), XrdSsiSfsConfig::Configure(), XrdSsiSfs::exists(), XrdSsiSfs::fsctl(), XrdSsiSfs::mkdir(), XrdSsiDir::open(), XrdSsiFile::open(), XrdSsiSfs::prepare(), XrdSsiSfs::rem(), XrdSsiSfs::remdir(), XrdSsiSfs::rename(), XrdSsiSfs::stat(), XrdSsiSfs::stat(), XrdSsiSfs::truncate(), XrdSfsGetFileSystem2(), and XrdVERSIONINFO().

## Trace

XrdSysTrace XrdSsi::Trace

Definition at line 107 of file XrdSsiSfs.cc.

Referenced by XrdSsiSfsConfig::Configure(), and XrdSfsGetFileSystem2().

## ubMutex

XrdSsiMutex XrdSsi::ubMutex(XrdSsiMutex::Recursive) | ( | XrdSsiMutex::Recursive |  | ) |